function [out] = fmt(in, in_type, out_type, normalized)
% general function that computes any fast mobius transform

% between any of m, b, pl, q, w
% into any in the same set + betp.
% fourth parameter optional, prodcue the normalized outcome, 
% can be anything, its presence is enough, but 'n' is clever.

% note that you can also use directly the fmt functions by calling them
% by xtoy(in). It is up to the user.

out = []; % just to avoir 'argument not assigned' when error

% we verify that the request is valid

% list of valid requests
v{1} = 'm'; v{2} = 'b'; v{3} = 'bel';v{4} = 'pl';v{5} = 'q'; v{6} = 'w';
in1 = strmatch(in_type,v,'exact');
v{7} = 'betp';
out1 = strmatch(out_type,v,'exact');

if length(in1) == 0|length(out1)==0
	'ACCIDENT in fmt: You have mistyped your request, one of the ..._types is not valid'
	fprintf('Your request was: %s %s \n',in_type, out_type)

else 
% check validity of request with ismember
lm = length(in);
natoms = round(log2(lm)); 
if 2^natoms == lm  % so size is OK
	
	% we first treat the betp request
	if out1 == 7
		if in1 == 1
			out = mtobetp(in);
		else
			out = eval(strcat('mtobetp(',in_type,'tom(in))'));
		end		
		
	% so it is not a betp request	
	else	
		if in_type == out_type
			out = in; % not very clever request, asking what you had!
		else
			out = eval(strcat(in_type,'to',out_type,'(in)'));
		end
		if nargin == 4
			out = normalize(out, out_type, natoms);
		end	
		
	end
else
	'ACCIDENT : the length of the in vector must be 2^nbr_atoms'
end
end

